%token <int> INT
%token SIZE NONE EOF

%type <int * (int option list)> main

%start main

%%

main:
  declaration definition EOF { ($1, $2) }

declaration:
  SIZE INT { $2 }

definition:
  value_list { $1 }

value_list:
  value_rlist { List.rev $1 }

value_rlist:
  value             { [$1] }
| value_rlist value { $2::$1 }

value:
  INT  { Some $1 }
| NONE { None }
